<?php
/*
Plugin Name: (a) sape Widget
Plugin URI: http://anton.shevchuk.name
Description: SAPE for your blog
Version: 0.1
Author: Anton Shevchuk
Author URI: http://anton.shevchuk.name
*/

/**
 * widget_sape_init
 *
 * init widget
 */
function widget_sape_init() 
{
	if (!function_exists('register_sidebar_widget')) {
		return;
	}
		
	### Function: (a) sape
	function widget_sape($args) {
		extract($args);
		$options = get_option('widget_sape');
		
		if (!is_array($options)) {
			$options = array(
			                 'request_uri' => '',
			                 'multi_site'  => false,
							 'verbose'     => false,
                             'charset'     => 'UTF-8',
                             'fetch_remote_type' => 'socket',
                             'socket_timeout'    => 6,
                             'force_show_code'   => false,
                             'debug'             => false,                             
                             '_SAPE_USER'        => false,                             
			                );
		}
		
        if (!$options['_SAPE_USER']) {
            return false;
        }
        
        if (!defined('_SAPE_USER')){
            define('_SAPE_USER', $options['_SAPE_USER']);
        }
        require_once _SAPE_USER.'/sape.php';
        $sape = new SAPE_client($options);
        echo $sape->return_links();
        
	}

	### Function: (a) Bsape Options
	function widget_sape_options() {
	    
		$options = get_option('widget_sape');
		
		if (!is_array($options)) {
			$options = array(
			                 'request_uri' => '',
			                 'multi_site'  => false,
							 'verbose'     => false,
                             'charset'     => 'UTF-8',
                             'fetch_remote_type' => 'socket',
                             'socket_timeout'    => 6,
                             'force_show_code'   => false,
                             'debug'             => false,                             
                             '_SAPE_USER'        => false,   
			                );
		}
		
		if ($_POST['sape-submit']) {
			$options['request_uri'] = strip_tags(addslashes($_POST['sape-request_uri']));		
			$options['multi_site']  = ($_POST['sape-multi_site'])?true:false;		
			$options['verbose']     = ($_POST['sape-verbose'])?true:false;		
			$options['charset']     = strip_tags(addslashes($_POST['sape-charset']));		
			$options['fetch_remote_type'] = strip_tags(addslashes($_POST['sape-fetch_remote_type']));		
			$options['socket_timeout']    = ($_POST['sape-socket_timeout']);		
			$options['force_show_code']   = ($_POST['sape-force_show_code'])?true:false;			
			$options['debug']             = ($_POST['sape-debug'])?true:false;	
			$options['_SAPE_USER']        = isset($_POST['sape-USER'])?$_POST['sape-USER']:false;	
			update_option('widget_sape', $options);
		}
		?>
        <p style="text-align: left;">
            <label for="sape-list"><?php _e('SAPE USER ID', 'a_sape');?> <font color="red">*</font>: </label>
            <input type="text" id="sape-USER" name="sape-USER" value="<?php echo htmlspecialchars(stripslashes($options['_SAPE_USER']));?>" />
        </p>
		<p style="text-align: left;">
            <label for="sape-list"><?php _e('Request URI (leave empty)', 'a_sape');?>: </label>
            <input type="text" id="sape-request_uri" name="sape-request_uri" value="<?php echo htmlspecialchars(stripslashes($options['request_uri']));?>" />
        </p>
        <p style="text-align: left;">
            <label for="sape-dir"><?php _e('Multi Site', 'a_sape');?>: </label>
            <select id="sape-multi_site" name="sape-multi_site" >
                <option value="1" <?php echo ($options['multi_site']===true)?' selected="selected"':'';?>>Yes</option>
                <option value="0" <?php echo ($options['multi_site']===false)?' selected="selected"':'';?>>No</option>
            </select>
        </p>
        <p style="text-align: left;">
            <label for="sape-dir"><?php _e('Verbose', 'a_sape');?>: </label>
            <select id="sape-verbose" name="sape-verbose" >
                <option value="1" <?php echo ($options['verbose']===true)?' selected="selected"':'';?>>Yes</option>
                <option value="0" <?php echo ($options['verbose']===false)?' selected="selected"':'';?>>No</option>
            </select>
        </p>
        <p style="text-align: left;">
            <label for="sape-dir"><?php _e('Charset', 'a_sape');?>: </label>
            <select id="sape-charset" name="sape-charset" >
                <option value="UTF-8" <?php echo ($options['charset']==='UTF-8')?' selected="selected"':'';?>>UTF-8</option>
                <option value="WINDOWS-1251" <?php echo ($options['charset']==='Windows-1251')?' selected="selected"':'';?>>Windows-1251</option>
            </select>
        </p>        
        <p style="text-align: left;">
            <label for="sape-dir"><?php _e('Remote Type', 'a_sape');?>: </label>
            <select id="sape-fetch_remote_type" name="sape-fetch_remote_type" >
                <option value="file_get_contents" <?php echo ($options['fetch_remote_type']==='file_get_contents')?' selected="selected"':'';?>>file_get_contents</option>
                <option value="curl" <?php echo ($options['fetch_remote_type']==='curl')?' selected="selected"':'';?>>curl</option>
                <option value="socket" <?php echo ($options['fetch_remote_type']==='socket')?' selected="selected"':'';?>>socket</option>
            </select>
        </p>
        <p style="text-align: left;">
            <label for="sape-dir"><?php _e('Socket Timeout', 'a_sape');?>: </label>
            <select id="sape-socket_timeout" name="sape-socket_timeout" >
                <option value="1" <?php echo ($options['socket_timeout']===1)?' selected="selected"':'';?>>1</option>
                <option value="2" <?php echo ($options['socket_timeout']===2)?' selected="selected"':'';?>>2</option>
                <option value="3" <?php echo ($options['socket_timeout']===3)?' selected="selected"':'';?>>3</option>
                <option value="4" <?php echo ($options['socket_timeout']===4)?' selected="selected"':'';?>>4</option>
                <option value="5" <?php echo ($options['socket_timeout']===5)?' selected="selected"':'';?>>5</option>
                <option value="6" <?php echo ($options['socket_timeout']===6)?' selected="selected"':'';?>>6</option>
                <option value="7" <?php echo ($options['socket_timeout']===7)?' selected="selected"':'';?>>7</option>
                <option value="8" <?php echo ($options['socket_timeout']===8)?' selected="selected"':'';?>>8</option>
                <option value="9" <?php echo ($options['socket_timeout']===9)?' selected="selected"':'';?>>9</option>
                <option value="10" <?php echo ($options['socket_timeout']===10)?' selected="selected"':'';?>>10</option>
            </select>
        </p>            
        <p style="text-align: left;">
            <label for="sape-dir"><?php _e('Force Show Code', 'a_sape');?>: </label>
            <select id="sape-force_show_code" name="sape-force_show_code" >
                <option value="1" <?php echo ($options['force_show_code']===true)?' selected="selected"':'';?>>Yes</option>
                <option value="0" <?php echo ($options['force_show_code']===false)?' selected="selected"':'';?>>No</option>
            </select>
        </p>        
        <p style="text-align: left;">
            <label for="sape-dir"><?php _e('Debug', 'a_sape');?>: </label>
            <select id="sape-debug" name="sape-debug" >
                <option value="1" <?php echo ($options['debug']===true)?' selected="selected"':'';?>>Yes</option>
                <option value="0" <?php echo ($options['debug']===false)?' selected="selected"':'';?>>No</option>
            </select>
        </p>
		<input type="hidden" id="sape-submit" name="sape-submit" value="1" />        
        <?php
	}
	
	// Register Widgets
	register_sidebar_widget(array('(a) sape', 'a-sape'), 'widget_sape');
	register_widget_control(array('(a) sape', 'a-sape'), 'widget_sape_options', 400, 200);
}

add_action('plugins_loaded', 'widget_sape_init');